var Drag = {

	obj : null,

	init : function(o, oRoot, minX, maxX, minY, maxY, bSwapHorzRef, bSwapVertRef, fXMapper, fYMapper)
	{
		o.onmousedown	= Drag.start;

		o.hmode			= bSwapHorzRef ? false : true ;
		o.vmode			= bSwapVertRef ? false : true ;

		o.root = oRoot && oRoot != null ? oRoot : o ;

		if (o.hmode  && isNaN(parseInt(o.root.style.left  ))) o.root.style.left   = "0px";
		if (o.vmode  && isNaN(parseInt(o.root.style.top   ))) o.root.style.top    = "0px";
		if (!o.hmode && isNaN(parseInt(o.root.style.right ))) o.root.style.right  = "0px";
		if (!o.vmode && isNaN(parseInt(o.root.style.bottom))) o.root.style.bottom = "0px";

		o.minX	= typeof minX != 'undefined' ? minX : null;
		o.minY	= typeof minY != 'undefined' ? minY : null;
		o.maxX	= typeof maxX != 'undefined' ? maxX : null;
		o.maxY	= typeof maxY != 'undefined' ? maxY : null;

		o.xMapper = fXMapper ? fXMapper : null;
		o.yMapper = fYMapper ? fYMapper : null;

		o.root.onDragStart	= new Function();
		o.root.onDragEnd	= new Function();
		o.root.onDrag		= new Function();
	},

	start : function(e)
	{

		var o = Drag.obj = this;
		e = Drag.fixE(e);
		var y = parseInt(o.vmode ? o.root.style.top  : o.root.style.bottom);
		var x = parseInt(o.hmode ? o.root.style.left : o.root.style.right );
		o.root.onDragStart(x, y);

		o.lastMouseX	= e.clientX;
		o.lastMouseY	= e.clientY;

		if (o.hmode) {
			if (o.minX != null)	o.minMouseX	= e.clientX - x + o.minX;
			if (o.maxX != null)	o.maxMouseX	= o.minMouseX + o.maxX - o.minX;
		} else {
			if (o.minX != null) o.maxMouseX = -o.minX + e.clientX + x;
			if (o.maxX != null) o.minMouseX = -o.maxX + e.clientX + x;
		}

		if (o.vmode) {
			if (o.minY != null)	o.minMouseY	= e.clientY - y + o.minY;
			if (o.maxY != null)	o.maxMouseY	= o.minMouseY + o.maxY - o.minY;
		} else {
			if (o.minY != null) o.maxMouseY = -o.minY + e.clientY + y;
			if (o.maxY != null) o.minMouseY = -o.maxY + e.clientY + y;
		}

		document.onmousemove	= Drag.drag;
		document.onmouseup	= Drag.end;


		return false;
	},

	drag : function(e)
	{
		e = Drag.fixE(e);
		var o = Drag.obj;

		var ey	= e.clientY;
		var ex	= e.clientX;
		var y = parseInt(o.vmode ? o.root.style.top  : o.root.style.bottom);
		var x = parseInt(o.hmode ? o.root.style.left : o.root.style.right );
		var nx, ny;

		if (o.minX != null) ex = o.hmode ? Math.max(ex, o.minMouseX) : Math.min(ex, o.maxMouseX);
		if (o.maxX != null) ex = o.hmode ? Math.min(ex, o.maxMouseX) : Math.max(ex, o.minMouseX);
		if (o.minY != null) ey = o.vmode ? Math.max(ey, o.minMouseY) : Math.min(ey, o.maxMouseY);
		if (o.maxY != null) ey = o.vmode ? Math.min(ey, o.maxMouseY) : Math.max(ey, o.minMouseY);

		nx = x + ((ex - o.lastMouseX) * (o.hmode ? 1 : -1));
		ny = y + ((ey - o.lastMouseY) * (o.vmode ? 1 : -1));

		if (o.xMapper)		nx = o.xMapper(y)
		else if (o.yMapper)	ny = o.yMapper(x)

		Drag.obj.root.style[o.hmode ? "left" : "right"] = nx + "px";
		Drag.obj.root.style[o.vmode ? "top" : "bottom"] = ny + "px";
		Drag.obj.lastMouseX	= ex;
		Drag.obj.lastMouseY	= ey;

		Drag.obj.root.onDrag(nx, ny);



		return false;
	},

	end : function()
	{
		var colorPicked;
		//Check array hue color - hueColor.txt
		var hueArray= new Array("ff0000", "ff0006", "ff000c", "ff0012", "ff0018", "ff001e", "ff0024", "ff002a", "ff0030", "ff0036", "ff003c", "ff0042", "ff0048", "ff004e", "ff0054", "ff005a", "ff0060", "ff0066", "ff006c", "ff0072", "ff0078", "ff007e", "ff0084", "ff008a", "ff0090", "ff0096", "ff009c", "ff00a2", "ff00a8", "ff00ae", "ff00b4", "ff00ba", "ff00c0", "ff00c6", "ff00cc", "ff00d2", "ff00d8", "ff00de", "ff00e4", "ff00ea", "ff00f0", "ff00f6", "ff00fc", "ff00ff", "f900ff", "f300ff", "ed00ff", "e700ff", "e100ff", "db00ff", "d500ff", "cf00ff", "c900ff", "c300ff", "bd00ff", "b700ff", "b100ff", "ab00ff", "a500ff", "9f00ff", "9900ff", "9300ff", "8d00ff", "8700ff", "8100ff", "7b00ff", "7500ff", "6f00ff", "6900ff", "6300ff", "5d00ff", "5700ff", "5100ff", "4b00ff", "4500ff", "3f00ff", "3900ff", "3300ff", "2d00ff", "2700ff", "2100ff", "1b00ff", "1500ff", "0f00ff", "0900ff", "0300ff", "0000ff", "0006ff", "000cff", "0012ff", "0018ff", "001eff", "0024ff", "002aff", "0030ff", "0036ff", "003cff", "0042ff", "0048ff", "004eff", "0054ff", "005aff", "0060ff", "0066ff", "006cff", "0072ff", "0078ff", "007eff", "0084ff", "008aff", "0090ff", "0096ff", "009cff", "00a2ff", "00a8ff", "00aeff", "00b4ff", "00baff", "00c0ff", "00c6ff", "00ccff", "00d2ff", "00d8ff", "00deff", "00e4ff", "00eaff", "00f0ff", "00f6ff", "00fcff", "00ffff", "00fff9", "00fff3", "00ffed", "00ffe7", "00ffe1", "00ffdb", "00ffd5", "00ffcf", "00ffc9", "00ffc3", "00ffbd", "00ffb7", "00ffb1", "00ffab", "00ffa5", "00ff9f", "00ff99", "00ff93", "00ff8d", "00ff87", "00ff81", "00ff7b", "00ff75", "00ff6f", "00ff69", "00ff63", "00ff5d", "00ff57", "00ff51", "00ff4b", "00ff45", "00ff3f", "00ff39", "00ff33", "00ff2d", "00ff27", "00ff21", "00ff1b", "00ff15", "00ff0f", "00ff09", "00ff03", "00ff00", "06ff00", "0cff00", "12ff00", "18ff00", "1eff00", "24ff00", "2aff00", "30ff00", "36ff00", "3cff00", "42ff00", "48ff00", "4eff00", "54ff00", "5aff00", "60ff00", "66ff00", "6cff00", "72ff00", "78ff00", "7eff00", "84ff00", "8aff00", "90ff00", "96ff00", "9cff00", "a2ff00", "a8ff00", "aeff00", "b4ff00", "baff00", "c0ff00", "c6ff00", "ccff00", "d2ff00", "d8ff00", "deff00", "e4ff00", "eaff00", "f0ff00", "f6ff00", "fcff00", "ffff00", "fff900", "fff300", "ffed00", "ffe700", "ffe100", "ffdb00", "ffd500", "ffcf00", "ffc900", "ffc300", "ffbd00", "ffb700", "ffb100", "ffab00", "ffa500", "ff9f00", "ff9900", "ff9300", "ff8d00", "ff8700", "ff8100", "ff7b00", "ff7500", "ff6f00", "ff6900", "ff6300", "ff5d00", "ff5700", "ff5100", "ff4b00", "ff4500", "ff3f00", "ff3900", "ff3300", "ff2d00", "ff2700", "ff2100", "ff1b00", "ff1500", "ff0f00", "ff0900", "ff0300");
		if(Drag.obj.lastMouseY <8 ) 
			posY=8;
		else if(Drag.obj.lastMouseY > 265)
			posY = 265
		else
			posY = Drag.obj.lastMouseY;

			posArrayProcessed = posY -8;
			colorPicked = hueArray[posArrayProcessed];
			hueColorClick(colorPicked,64);

		document.onmousemove = null;
		document.onmouseup   = null;
		Drag.obj.root.onDragEnd(	parseInt(Drag.obj.root.style[Drag.obj.hmode ? "left" : "right"]), 
									parseInt(Drag.obj.root.style[Drag.obj.vmode ? "top" : "bottom"]));
	

		
		Drag.obj = null;
	},

	fixE : function(e)
	{
		if (typeof e == 'undefined') e = window.event;
		if (typeof e.layerX == 'undefined') e.layerX = e.offsetX;
		if (typeof e.layerY == 'undefined') e.layerY = e.offsetY;
		return e;
	}
};